
#ifndef DEFS_H
#define DEFS_H

#define RELEASE "0.16"

#define SUPPORT_LAPIS
#define SUPPORT_PERL
#define SUPPORT_PYTHON
// #define SUPPORT_PHP

#define WEBDIR "/Users/zack/www/"
#define LOGFILE "/Users/zack/www.log"
#define ATTACKERS_FILE "/Users/zack/attackers"

#ifndef MAXPATH
#define MAXPATH 4096
#endif

#define MAXCOOKIES 20  /* per request */
#define MAXCOOKIELENGTH 4096

#define MAXREQ (MAXCOOKIES * MAXCOOKIELENGTH + 16000)
#define REQLEN (MAXCOOKIES * MAXCOOKIELENGTH + 16370)

typedef char bool;
enum { false=0, true=1 };

typedef unsigned long IP;

#define FATAL(AA) { fprintf (stderr, "Fatal in %s(): %s\n", __FUNCTION__, AA); exit(-1); }
#define WARNING(AA) { fprintf (stderr, "Warning from %s(): %s\n", __FUNCTION__, AA);  }

enum {
	HTTP_ERR_MOVED = 301,
	HTTP_ERR_BAD_REQUEST = 400,
	HTTP_ERR_UNAUTH = 401,
	HTTP_ERR_FORBIDDEN = 403,
	HTTP_ERR_NOT_FOUND = 404,
	HTTP_ERR_INTERNAL = 500,
	HTTP_ERR_BAD_EXTN = 999
};

enum {
	EXITCODE_HTTPERR_MOVED = 60,
	EXITCODE_HTTPERR_BAD_REQUEST = 61,
	EXITCODE_HTTPERR_UNAUTH = 62,
	EXITCODE_HTTPERR_FORBIDDEN = 63,
	EXITCODE_HTTPERR_NOT_FOUND = 64,
	EXITCODE_HTTPERR_INTERNAL =65,
	EXITCODE_PORTSCAN=66,
	EXITCODE_PARAM_ATTACK=67,
	EXITCODE_FLOCK_FAILED=68,
	EXITCODE_NOMEM=69,
	EXITCODE_HTTPERR_OTHER = 70,
	EXITCODE_READ_ERROR= 71,
	EXITCODE_FEW_PARAMS=72,
	EXITCODE_HTTP_ATTACK=73,
	EXITCODE_BUFFER_ATTACK=74,
	EXITCODE_IGNORE=75,
	EXITCODE_SHORT=76,
	EXITCODE_BADREQ=77, // e.g. SEARCH
	EXITCODE_POISONING=78,
};

enum {
	HEADER_HAS_AUTHORIZATION=1,
	HEADER_BAD_USERAGENT=2,
};

enum { 
	EXTN_NONE=0,
	EXTN_HTML=1,
	EXTN_PL=2,
	EXTN_PY=3,
	EXTN_PHP=4,
	EXTN_JPG=5,
	EXTN_GIF=6,
	EXTN_PNG=7,
	EXTN_MPG=8,
	EXTN_AVI=9,
	EXTN_ICO=10,
	EXTN_MP3=11,
	EXTN_OGG=12,
	EXTN_JS=13,
	EXTN_LAPIS=14,
	EXTN_TIF=15,
};

enum {
	PARAM_HOST=1,
	PARAM_USERAGENT=2,
	PARAM_ACCEPT=3,
	PARAM_ACCEPTLANGUAGE=4,
	PARAM_ACCEPTENCODING=5,
	PARAM_ACCEPTCHARSET=6,
	PARAM_KEEPALIVE=7,
	PARAM_CONNECTION=8,
	PARAM_AUTHORIZATION=9,
	PARAM_REFERER=10,
	PARAM_CACHECONTROL=11,
	PARAM_COOKIE=12,
	PARAM_CONTENTLENGTH=13,
};

typedef struct {
	char *name;
	char code;
	char *contents;
}
StringPair;

typedef struct li {
	pid_t	pid;
	IP	addr;
	struct li 	*next;
} 
ListItem;

typedef struct sli {
	int	fd;
	pid_t	pid;
	struct sli 	*next; 
} 
AddrListSubItem;

typedef struct li2 {
	IP	addr;
	AddrListSubItem	*list;
	struct li2 	*next;
} 
AddrListItem;

extern void maketempfile (char*);
extern int send_results (int,char*,char*);
extern int http_error (int,int);
extern void log_write (char*);
extern void log_writeln (char*);
extern void log_store (void);
extern int myexit (int);
extern int stat_file (char *path);

extern void error (int which);
extern void warning (char *s);
extern bool my_strcasestr (char *s, char *s2);

#endif

