
/*===========================================================================
 * Lapis, a simple webserver.
 * Version 0.13
 * Copyright (C) 2005,2011 by Zachary Smith.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *=========================================================================*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/stat.h>
#include <string.h>

#include "defs.h"


int myexit(int foo)
{
	exit(foo);
}


void maketempfile (char *path)
{
        strcpy (path, "/tmp/_lapis_XXXXXX");
        mkstemp (path);
}

int stat_file (char *path)
{
        if (!path)
                return -1;

        struct stat st;
        if (stat (path, &st)) {
                perror ("stat");
                return -1;
        }

        return st.st_size;
}


void error (int which)
{
	fprintf (stderr, "Error! #%d\n", which);
	myexit(32+which);
}

void warning (char *s)
{
	fprintf (stderr, "Warning! %s\n", s);
}


bool my_strcasestr (char *s, char *s2)
{
	if (!s || !s2)
		return false;

	while (*s) {
		if (tolower(*s) == tolower(*s2)) {
			if (!strcasecmp(s+1,s2+1))
				return true;
		}	
		s++;
	}
	return false;
}


